#################################################################
#     ___                       __                 _            #
#    /___\_ __  _   ___  __    / _\ ___ _ ____   _(_) ___ ___   #
#   //  // '_ \| | | \ \/ /    \ \ / _ \ '__\ \ / / |/ __/ _ \  #
#  / \_//| | | | |_| |>  <     _\ \  __/ |   \ V /| | (_|  __/  #
#  \___/ |_| |_|\__, /_/\_\    \__/\___|_|    \_/ |_|\___\___|  #
#               |___/                                           #
#                                                               #
#                                                               #
#                     Module : HelpServ - Bot d'aides           #
#                     Auteur : ludo`                            #
#                       Site : www.onyxservice.zone-irc.com     #
#            Type de serveur : UnrealIRCd                       #
#                                                               #
#################################################################


#############################
#---------------------------#
# Configuration de HelpServ #
#---------------------------#
#############################
## Activation de HelpServ (0=dsactiv 1=activ)
set ::onyx(hs:global:active) "1"
## Pseudo de HelpServ
set ::onyx(hs:pseudo) "HelpServ"
## Identd de HelpServ
set ::onyx(hs:ident) "helpserv"
## Realname de HelpServ
set ::onyx(hs:real) "Bot d'aide --> Onyx Service"
## Host de HelpServ
set ::onyx(hs:host) "helpserv.zone-irc.com"
## Mode de HelpServ
set ::onyx(hs:mode) "+SBqW"
## Salon de HelpServ
set ::onyx(hs:salon) "#Aide"
## Mode de HelpServ sur le salon (q=owner a=protect o=op h=halfop v=voice)
set ::onyx(hs:mode_pseudo) "+o"
## Mode du salon de HelpServ
set ::onyx(hs:mode_salon) "+nt"
## Rponse (notice)  un utilisateur l'ors d'un /helpop inexistant (0=dsactiv 1=activ)
set ::onyx(hs:helpop:action) "1"
## Notice  l'utilisateur l'ors d'un /helpop inexistant (0=dsactiv 1=activ)
## ('ps=personne qui demande l'aide' et 'hp=l'aide qu'il cherche')
set ::onyx(hs:helpop:notice) "Bonjour ps, essai de demander de l'aide pour hp sur notre salon d'aide $::onyx(hs:salon)."

#############################################################################################################################

###############
# Fichiers db #
###############
proc hs:db {} {
  if {![file isdirectory [pwd]/db/hs_onyx/]} { utimer 1 [file mkdir [pwd]/db/hs_onyx/] }
  set nom_db "gestion.db help.db"
  foreach nom_db2 $nom_db { 
    if {![file exists "db/hs_onyx/$nom_db2"]} { set hs_db [open db/hs_onyx/$nom_db2 a+]; close $hs_db }
  }
}

#############
# Lancement #
#############
proc hs:lancement {} {
  ## Gestion
  set gestion_hs [open db/hs_onyx/gestion.db r]
  foreach var [split [read $gestion_hs] "\n"] {
    if {$var!=""} { set [lindex $var 0] [lrange $var 1 end] } 
  }
  close $gestion_hs
  ## Connextion
  if {$::onyx(hs:global:active)=="1"} {
    putdcc $::onyx(idx) ":$::onyx(link) NICK $::onyx(hs:pseudo) 1 [unixtime] $::onyx(hs:ident) $::onyx(hs:host) $::onyx(link) :$::onyx(hs:real)"
    if {$::onyx(swhoisbot)=="1"} { putdcc $::onyx(idx) ":$::onyx(os:pseudo) SWHOIS $::onyx(hs:pseudo) :Bot de Onyx Service" }
    putdcc $::onyx(idx) ":$::onyx(hs:pseudo) MODE $::onyx(hs:pseudo) $::onyx(hs:mode)"
    putdcc $::onyx(idx) ":$::onyx(hs:pseudo) JOIN $::onyx(hs:salon)"
    putdcc $::onyx(idx) ":$::onyx(hs:pseudo) MODE $::onyx(hs:salon) $::onyx(hs:mode_pseudo) $::onyx(hs:pseudo)"
    putdcc $::onyx(idx) ":$::onyx(hs:pseudo) MODE $::onyx(hs:salon) $::onyx(hs:mode_salon)"
    set ::onyx(os:host:[string tolower $::onyx(hs:pseudo)]) $::onyx(hs:host)
    set ::onyx(bot:[string tolower $::onyx(hs:pseudo)]) OnyxService
  }
  ############
  if {$::onyx(hs:global:active)=="1"  && $::onyx(salon2)!=[string tolower $::onyx(hs:salon)]} {
    putdcc $::onyx(idx) ":$::onyx(hs:pseudo) JOIN $::onyx(salon)"
    putdcc $::onyx(idx) ":$::onyx(hs:pseudo) MODE $::onyx(salon) $::onyx(mode_bots_salon) $::onyx(hs:pseudo)"
  }
}

##########
# Divers #
##########
proc hs:divers {arg} {
  set arg [stripcodes cb [join [split $arg]]]
  set data [lindex $arg 0]
  set data2 [lindex $arg 1] 
  switch -exact $data {
  "help" { putdcc $data2 "HelpServ : .connexion_hs connexion de $::onyx(hs:pseudo) | .deconnexion_hs dconnexion de $::onyx(hs:pseudo)\r" }
  "status" { if {$::onyx(hs:global:active)=="1"} { putdcc $data2 "HelpServ (Activ) : Pseudo: $::onyx(hs:pseudo) Salon: $::onyx(hs:salon)\r" } else { putdcc $data2 "HelpServ (Dsactiv) : Pseudo: $::onyx(hs:pseudo) Salon: $::onyx(hs:salon)\r" } }
  "gestion" {
    set sauv_hs [open db/hs_onyx/gestion.db w+]
    puts $sauv_hs "::onyx(hs:global:active) $::onyx(hs:global:active)"
    puts $sauv_hs "::onyx(hs:pseudo) $::onyx(hs:pseudo)"
    puts $sauv_hs "::onyx(hs:ident) $::onyx(hs:ident)"
    puts $sauv_hs "::onyx(hs:host) $::onyx(hs:host)"
    puts $sauv_hs "::onyx(hs:real) $::onyx(hs:real)"
    puts $sauv_hs "::onyx(hs:salon) $::onyx(hs:salon)"
    close $sauv_hs
  }
  "chanlog" { if {$::onyx(hs:global:active)=="1"} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) PART $::onyx(salon) :Changement de salon" } }
  }
}

###################
# hs:connexion_hs #
###################
bind dcc n connexion_hs hs:connexion_hs
proc hs:connexion_hs {nick idx arg} { 
   if {$::onyx(hs:global:active)=="0"} { 
     putdcc $idx "Connexion de $::onyx(hs:pseudo)"
     set ::onyx(hs:global:active) 1
     set ::onyx(os:host:[string tolower $::onyx(hs:pseudo)]) $::onyx(hs:host)
     putdcc $::onyx(idx) ":$::onyx(link) NICK $::onyx(hs:pseudo) 1 [unixtime] $::onyx(hs:ident) $::onyx(hs:host) $::onyx(link) :$::onyx(hs:real)"
     putdcc $::onyx(idx) ":$::onyx(hs:pseudo) MODE $::onyx(hs:pseudo) $::onyx(hs:mode)"
     putdcc $::onyx(idx) ":$::onyx(hs:pseudo) JOIN $::onyx(hs:salon)"
     putdcc $::onyx(idx) ":$::onyx(hs:pseudo) MODE $::onyx(hs:salon) $::onyx(hs:mode_pseudo) $::onyx(hs:pseudo)"
     putdcc $::onyx(idx) ":$::onyx(hs:pseudo) MODE $::onyx(hs:salon) $::onyx(hs:mode_salon)"
     if {$::onyx(salon2)!=[string tolower $::onyx(hs:salon)]} {
       putdcc $::onyx(idx) ":$::onyx(hs:pseudo) JOIN $::onyx(salon)"
       putdcc $::onyx(idx) ":$::onyx(hs:pseudo) MODE $::onyx(salon) $::onyx(mode_bots_salon) $::onyx(hs:pseudo)"
     }
     onyx:gestion
   } else { putdcc $idx "$::onyx(hs:pseudo) est dj connect..." }
}

#####################
# hs:deconnexion_hs #
#####################
bind dcc n deconnexion_hs hs:deconnexion_hs
proc hs:deconnexion_hs {nick idx arg} { 
   if {$::onyx(hs:global:active)=="1"} { 
     putdcc $idx "Dconnexion de $::onyx(hs:pseudo)"
     set ::onyx(hs:global:active) 0
     unset -nocomplain ::onyx(os:host:[string tolower $::onyx(hs:pseudo)])
     putdcc $::onyx(idx) ":$::onyx(hs:pseudo) QUIT :$::onyx(raison)" 
     onyx:gestion
     } else { putdcc $idx "$::onyx(hs:pseudo) est dj dconnect..." }
}

###########
# hs:help #
###########
proc hs:help {arg} {
        set arg [stripcodes cb [join [split $arg]]]
        set pseudo [lindex $arg 0]
        set vpseudo [string tolower $pseudo]
        set data [lindex $arg 2]
        set data2 [string tolower $data]
        set data3 [string tolower [lindex $arg 3]]
        switch -exact $data2 {
        "" {
         if {[info exists ::onyx(os:$vpseudo)] && [matchattr $::onyx(os:$vpseudo) n]} {
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :SET Permet de configurer $::onyx(hs:pseudo)."
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :HELPADD Permet d'ajouter une commande d'aide."
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :HELPDEL Permet de supprimer une commande d'aide."
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :HELPLIST Permet de voir la liste des commandes d'aide."
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :"
          }   
          set stop 0
          set help_hs [open db/hs_onyx/help.db r]
          foreach var_help [split [read $help_hs] "\n"] {
            if {$var_help!=""} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :HELP [lindex $var_help 0] [lrange $var_help 2 end]"; set stop 1 } 
            if {$stop=="0"} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Aucune aide disponible." }
          }
          close $help_hs
        }
        "set" {
          switch -exact $data3 {
          "" {
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :PSEUDO Permet de changer le pseudo du bot."
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :IDENT Permet de changer l'ident du bot."
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :HOST Permet de changer l'host du bot."
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :REALNAME Permet de changer le realname du bot."
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :SALON Permet de changer le salon principal du bot."
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :LIST Permet de montrer les fixations actuelles du bot."
          }
          "pseudo" {
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Syntax: /msg $::onyx(hs:pseudo) set pseudo nouveau_pseudo"
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Permet de changer le pseudo du bot."
          }
          "ident" {
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Syntax: /msg $::onyx(hs:pseudo) set ident nouveau_ident"
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Permet de changer l'ident du bot."
          }
          "host" {
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Syntax: /msg $::onyx(hs:pseudo) set host nouveau_host"
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Permet de changer l'host du bot."
          }
          "realname" {
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Syntax: /msg $::onyx(hs:pseudo) set realname nouveau_realname"
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Permet de changer le realname du bot."
          }
          "salon" {
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Syntax: /msg $::onyx(hs:pseudo) set salon #nouveau_salon"
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Permet de changer le salon principal du bot."
          }
          "list" {
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Syntax: /msg $::onyx(hs:pseudo) set list"
            putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Permet de montrer les fixations actuelles du bot."
          }
          default { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Pour connaitre les commandes disponible pour $data2 tapez /msg $::onyx(hs:pseudo) $data2." }
          }
        }
        "addhelp" {
            putdcc $::onyx(idx) ":$::onyx(os:pseudo) NOTICE $pseudo :Syntax: /msg $::onyx(os:pseudo) addhelp commande fichier.txt description"
            putdcc $::onyx(idx) ":$::onyx(os:pseudo) NOTICE $pseudo :Permet d'ajouter une commande d'aide."
        }
        "delhelp" {
            putdcc $::onyx(idx) ":$::onyx(os:pseudo) NOTICE $pseudo :Syntax: /msg $::onyx(os:pseudo) delhelp commande"
            putdcc $::onyx(idx) ":$::onyx(os:pseudo) NOTICE $pseudo :Permet de supprimer une commande d'aide."
        }
        helplist" {
            putdcc $::onyx(idx) ":$::onyx(os:pseudo) NOTICE $pseudo :Syntax: /msg $::onyx(os:pseudo) helplist"
            putdcc $::onyx(idx) ":$::onyx(os:pseudo) NOTICE $pseudo :Permet de voir la liste des commandes d'aide."
        }
        default { 
          set data4 [string toupper [lindex $arg 2]]
          set stop 0
          set help_cmd [open db/hs_onyx/help.db r]
          foreach var_helpcmd [split [read $help_cmd] "\n"] {
            if {[lindex $var_helpcmd 0]==$data4} { 
              set stop 1
              set cmd_helpcmd [lindex $var_helpcmd 0]
              set fichier_helpcmd [lindex $var_helpcmd 1]
              break 
            } 
          }
          close $help_cmd
          if {$stop=="1"} {
            if {![file exists db/hs_onyx/help/$fichier_helpcmd]} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Le fichier d'aide pour $cmd_helpcmd n'existe pas ou plus, prenez contact avec l'administrateur du service --> $::admin"; return 0 }
            set liste [open db/hs_onyx/help/$fichier_helpcmd r]
            foreach help [split [read $liste] "\n"] {
	      if {$help!=""} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :$help" } 
	    }
	   close $liste
          } 
          if {$stop=="0"} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Aucune aide disponible pour la commande $data2." }
        }
        }
}

##########
# hs:set #
##########
proc hs:set {arg} {
	set arg [stripcodes cb [join [split $arg]]]
	set pseudos [lindex $arg 0]
	set pseudo [lindex [split $pseudos :] 0]
	set vpseudo [string tolower $pseudo]
	set pseudo2 [lindex [split $pseudos :] 1]
	set data [string tolower [lindex $arg 2]]
	set data2 [lindex $arg 3]
	set vdata2 [string tolower $data2]
        if {$pseudo2==""} { set par "$pseudo" } else { set par "L'administration web : $pseudo2" }
        if {![info exists ::onyx(os:$vpseudo)]} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Commande Auth : /msg $::onyx(os:pseudo) auth pseudo motdepasse"; return 0 }
        if {![matchattr $::onyx(os:$vpseudo) n]} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Votre  level est insuffisant pour utilser cette commande."; return 0 }
	switch -exact $data {
        "" { 
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :PSEUDO Permet de changer le pseudo du bot."
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :IDENT Permet de changer l'ident du bot."
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :HOST Permet de changer l'host du bot."
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :REALNAME Permet de changer le realname du bot."
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :SALON Permet de changer le salon principal du bot."
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :LIST Permet de montrer les fixations actuelles du bot."
          return 0 
	}
	"pseudo" {
          if {$data2==""} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Commande Set pseudo : /msg $::onyx(hs:pseudo) set pseudo nouveau_pseudo"; return 0 }
          if {$vdata2==[string tolower $::onyx(hs:pseudo)]} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Pseudo Identique."; return 0 }
          set new_pseudo $data2
          set ::onyx(verif:pseudo_bot) "hs $new_pseudo $pseudos 0"
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) WHO $new_pseudo"
        }
	"ident" {
          if {$data2==""} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Commande Set ident : /msg $::onyx(hs:pseudo) set ident nouveau_ident"; return 0 }
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) SETIDENT $data2"
          set ::onyx(hs:ident) $data2
          onyx:gestion
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Changement de l'ident russi."
          if {$::onyx(os:console)=="1"} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) PRIVMSG $::onyx(salon) :$::onyx(os:couleur_evmt)Set ident$::onyx(os:couleur_deco) : $::onyx(os:couleur_txt)utilis par $par" }
        }
	"host" {
          if {$data2==""} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Commande Set host : /msg $::onyx(hs:pseudo) set host nouveau_host"; return 0 }
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) SETHOST $data2"
          set ::onyx(os:host:[string tolower $::onyx(hs:pseudo)]) $data2
          set ::onyx(hs:host) $data2
          onyx:gestion
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Changement de l'host russi."
          if {$::onyx(os:console)=="1"} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) PRIVMSG $::onyx(salon) :$::onyx(os:couleur_evmt)Set host$::onyx(os:couleur_deco) : $::onyx(os:couleur_txt)utilis par $par" }
        }
	"realname" {
          if {$data2==""} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Commande Set realname : /msg $::onyx(hs:pseudo) set realname nouveau_realname"; return 0 }
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) SETNAME :[lrange $arg 3 end]"
          set ::onyx(hs:real) [lrange $arg 3 end]
          onyx:gestion
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Changement du realname russi."
          if {$::onyx(os:console)=="1"} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) PRIVMSG $::onyx(salon) :$::onyx(os:couleur_evmt)Set realname$::onyx(os:couleur_deco) : $::onyx(os:couleur_txt)utilis par $par" }
        }
	"salon" {
          if {$data2==""} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Commande Set salon : /msg $::onyx(hs:pseudo) set salon #nouveau_salon"; return 0 }
          if {[string index $data2 0]!="#"} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Vous avez oublier le # devant le nouveau salon."; return 0 } 
          if {$vdata2==[string tolower $::onyx(hs:salon)]} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Salon Identique."; return 0 }
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) PART $::onyx(hs:salon) :Changement de salon"
          set ::onyx(hs:salon) $data2
          onyx:gestion
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) JOIN $::onyx(hs:salon)"
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) MODE $::onyx(hs:salon) $::onyx(hs:mode_pseudo) $::onyx(hs:pseudo)"
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Changement du salon russi."
          if {$::onyx(os:console)=="1"} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) PRIVMSG $::onyx(salon) :$::onyx(os:couleur_evmt)Set salon$::onyx(os:couleur_deco) : $::onyx(os:couleur_txt)utilis par $par" }
        }
	"list" {
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Pseudo: $::onyx(hs:pseudo)"
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Ident: $::onyx(hs:ident)"
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Host: $::onyx(hs:host)"
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Realname: $::onyx(hs:real)"
          putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Salon: $::onyx(hs:salon)"
        }
        default { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Commande SET $data inconnue, tapez /msg $::onyx(gs:pseudo) set afin de connaitre les commandes." }
	}
}

############
# hs:ghelp #
############
proc hs:ghelp {arg} {
	set arg [stripcodes cb [join [split $arg]]]
        set pseudo [lindex $arg 0]
        set vpseudo [string tolower $pseudo]
        set cmd [string trim [string trim [lindex $arg 1] :] $::onyx(prefix)]
        set vcmd [string tolower $cmd]
        set data [string toupper [lindex $arg 2]]
        set data2 [string tolower [lindex $arg 3]]
        set data3 [lrange $arg 4 end]
        if {![info exists ::onyx(os:$vpseudo)]} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Commande Auth : /msg $::onyx(os:pseudo) auth pseudo motdepasse"; return 0 }
	switch -exact $vcmd {
        "helpadd" { 
          if {![matchattr $::onyx(os:$vpseudo) m]} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Votre level est insuffisant pour utilser cette commande."; return 0 }
	  if {$data=="" || $data2=="" || $data3==""} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Commande Helpadd : /msg $::onyx(hs:pseudo) addhelp commande fichier.txt description"; return 0 }
          set stop 0
          set liste [open db/hs_onyx/help.db r]
          foreach verif [split [read $liste] "\n"] {
	    if {[lindex $verif 0]==$data} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :$data est dj dans la liste des aides."; set stop 1; break }
	    if {[lindex $verif 1]==$data2} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Le fichier $data2 est dj utilis."; set stop 1; break }
	    if {[lrange $verif 2 end]==$data3} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :La description $data3 est dj utilis pour [lindex $verif 0]."; set stop 1; break }
	  }
	  close $liste
	  if {$stop==1} { return 0 }
	  set help [open db/hs_onyx/help.db a]
	  puts $help "$data $data2 $data3"
	  close $help
	  putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :$data vient d'tre ajout  la liste d'aides."
	  putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :N'oubliez pas de mettre votre fichier $data2 dans le dossier db/hs_onyx/help/"
	  if {$::onyx(os:console)=="1"} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) PRIVMSG $::onyx(salon) :$::onyx(os:couleur_evmt)Helpadd$::onyx(os:couleur_deco) : $::onyx(os:couleur_txt)$data ajout par $pseudo" }
        }
        "helpdel" { 
          if {![matchattr $::onyx(os:$vpseudo) m]} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Votre level est insuffisant pour utilser cette commande"; return 0 }
	  if {$data==""} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Commande Delhelp : /msg $::onyx(hs:pseudo) Helpdel commande"; return 0 }
	  set stop 0
          set liste [open db/hs_onyx/help.db r]
          foreach verif [split [read $liste] "\n"] {
	    if {[lindex $verif 0]==$data} { set stop 1 }
	    if {[lindex $verif 0]!=$data && $verif!=""} { lappend help "$verif" }
	  }
	  close $liste
	  if {$stop==0} { 
	    putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :$data n'est pas dans la liste d'aide." 
	    return 0 
	  } else {
	    if [info exists help] {
	    set delhelp [open db/hs_onyx/help.db w+]
	    foreach helpcmd $help { puts $delhelp "$helpcmd" }
	    close $delhelp
	  } else {
	    set delhelp [open db/hs_onyx/help.db w+]
	    close $delhelp
	  }
	  putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :$data vient d'tre supprim de la liste d'aide."
	  if {$::onyx(os:console)=="1"} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) PRIVMSG $::onyx(salon) :$::onyx(os:couleur_evmt)Helpdel$::onyx(os:couleur_deco) : $::onyx(os:couleur_txt)$data supprim par $pseudo" }
          }
        }
        "helplist" {
          if {![matchattr $::onyx(os:$vpseudo) m]} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Votre level est insuffisant pour utilser cette commande."; return 0 }
	  set num 0
          set liste [open db/hs_onyx/help.db r]
	  putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :1,1---------- 0Liste des commandes d'aide 1----------"
	  putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :"
          foreach help [split [read $liste] "\n"] {
	    if {$help!=""} { 
              incr num 1
              set commande [lindex $help 0]
              set fichier [lindex $help 1]
              if {![file exists db/hs_onyx/help/$fichier]} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo : 1 \[03 $num 01\] 01commande: $commande fichier: $fichier 4Fichier inxistant" } else { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo : 1 \[03 $num 01\] 01commande: $commande fichier: $fichier" }
	    } 
	  }
	  close $liste
	  if {$num=="0"} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Aucune commande d'aide." }
	  if {$::onyx(os:console)=="1"} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) PRIVMSG $::onyx(salon) :$::onyx(os:couleur_evmt)Helplist$::onyx(os:couleur_deco) : $::onyx(os:couleur_txt)utilis par $pseudo" }
        }
        }
}

############
# hs:event #
############
proc hs:event {arg} {
   set arg [join [split $arg]]
switch -exact [lindex $arg 1] {
  "JOIN" 
    { 
    set pseudo [string trim [lindex $arg 0] :]
    set vpseudo [string tolower $pseudo]
    set salon [lindex $arg 2]
    set vsalon [string tolower $salon]
    if {$::onyx(hs:global:active)=="1" && $vsalon==[string tolower $::onyx(hs:salon)] && ![info exists ::onyx(bot:$vpseudo)] } { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $vpseudo :Bienvenue sur $salon, Tapez $::onyx(prefix)help afin de ne pas dranger les oprateurs pour les questions les plus courantes ;)" }
    }
  "PRIVMSG" 
    { 
    set arg [stripcodes cb $arg]
    set pseudo [string trim [lindex $arg 0] :]
    set vpseudo [string tolower $pseudo]
    set pour [lindex $arg 2]
    set vpour [string tolower $pour]
    set commande [string tolower [string trim [lindex $arg 3] :]]
    set commande2 [string trim $commande $::onyx(prefix)]
    set data [lrange $arg 3 end]
    if {$vpour==[string tolower $::onyx(hs:pseudo)] || $vpour==[string tolower $::onyx(hs:salon)]} { 
      if {[string tolower $::onyx(hs:salon)]==$::onyx(salon2) && $vpour!=[string tolower $::onyx(hs:pseudo)]} { return 0 }
      if {[string match *#* $pour] && [string index $commande 0]!=$::onyx(prefix)} { return 0 }
      if {![string match *#* $pour] && [string index $commande 0]==$::onyx(prefix)} { return 0 }
      if {[global:flood "hs $pseudo"]!="ok"} { return 0 }
      switch -exact $commande2 {
        "help" { hs:help "$pseudo $data" }
        "set" { hs:set "$pseudo $data" }
        "helpadd" { hs:ghelp "$pseudo $data" }
        "helpdel" { hs:ghelp "$pseudo $data" }
        "helplist" { hs:ghelp "$pseudo $data" }
        default { if {$vpour==[string tolower $::onyx(hs:pseudo)] && ![string match ** $commande]} { putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :Commande $commande2 inconnue. Tapez /msg $::onyx(hs:pseudo) help pour obtenir de l'aide." } }
      }
    }
    }
  "HELP" 
    { 
    set pseudo [string trim [lindex $arg 0] :]
    set aide [lindex $arg 2]
    if {$::onyx(hs:helpop:action)=="1"} {
      regsub -all "ps" $::onyx(hs:helpop:notice) "$pseudo" ::onyx(hs:helpop:notice2)
      regsub -all "hp" $::onyx(hs:helpop:notice2) "$aide" ::onyx(hs:helpop:notice3)
      putdcc $::onyx(idx) ":$::onyx(hs:pseudo) NOTICE $pseudo :$::onyx(hs:helpop:notice3)"
    }
    }
  }
}

##########
# hs:web #
##########
proc hs:web {arg} {
   set htmlpage [lindex $arg 0]
   set num_menu [lindex $arg 1]
   puts $htmlpage "<table width=\"85%\" align=\"center\" id=\"menu$num_menu\" style=\"display: none; text-align: center\"><tr><td>"
   puts $htmlpage "<table width=\"100%\" align=\"center\"><tr>"
   puts $htmlpage "<td width=\"60%\" valign=\"top\">"
   puts $htmlpage "<font class=\"text1\">Pseudo du HelpServ :</font> $::onyx(hs:pseudo)<br>"
   puts $htmlpage "<font class=\"text1\">Ident du HelpServ :</font> $::onyx(hs:ident)<br>"
   puts $htmlpage "<font class=\"text1\">Host du HelpServ :</font> $::onyx(hs:host)<br>"
   puts $htmlpage "<font class=\"text1\">Modes du HelpServ :</font> $::onyx(hs:mode)<br>"
   puts $htmlpage "<font class=\"text1\">Realname du HelpServ :</font> $::onyx(hs:real)<br>"
   puts $htmlpage "<font class=\"text1\">Salon du HelpServ :</font> $::onyx(hs:salon)<br>"
   puts $htmlpage "<font class=\"text1\">Modes du salon :</font> $::onyx(hs:mode_salon)<br>"
   puts $htmlpage "<font class=\"text1\">Mode sur le salon :</font> $::onyx(hs:mode_pseudo)<br>"
   if {$::onyx(hs:global:active)=="1"} { puts $htmlpage "<font class=\"text1\">HelpServ activ :</font> Oui<br>" } else { puts $htmlpage "<font class=\"text1\">HelpServ activ :</font> Non<br>" }
   puts $htmlpage "</td><td valign=\"top\">"
   if {$::onyx(hs:helpop:action)=="1"} { puts $htmlpage "<font class=\"text1\">Notice (helpop) activ :</font> Oui<br>" } else { puts $htmlpage "<font class=\"text1\">Notice (helpop) activ :</font> Non<br>" }
   puts $htmlpage "</td></tr></table>"
   puts $htmlpage "<div align=\"center\">"
   puts $htmlpage "<br><table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" class=\"tab\" align=\"center\">"
   puts $htmlpage "<tr><td align=\"center\" class=\"bord\">Commande</td><td align=\"center\" class=\"bord\">Fichier</td><td align=\"center\" class=\"bord\">Description</td><td></td></tr>"
   set num 0
   set liste_help [open db/hs_onyx/help.db r]
   foreach help_htm [split [read $liste_help] "\n"] {
     if {$help_htm!=""} {
       incr num 1
       set cmd_htm [lindex $help_htm 0]
       set fichier_htm [lindex $help_htm 1]
       set desc_htm [lrange $help_htm 2 end]
       if {![file exists db/hs_onyx/help/$fichier_htm]} { set exist_fichier_html "<img src=\"images/non.gif\" alt=\"\">" } else { set exist_fichier_html "<img src=\"images/oui.gif\" alt=\"\">" }
       puts $htmlpage "<tr><td align=\"center\">$cmd_htm</td><td align=\"center\">$fichier_htm $exist_fichier_html</td><td align=\"center\">$desc_htm</td></tr>"
     }
   }
   catch {close $liste_help}
        if {$num=="0"} { puts $htmlpage "<tr><td></td><td align=\"center\">Aucune commande d'aide.</td><td></td></tr>" }
   puts $htmlpage "</table>"
        if {$num!="0"} { puts $htmlpage "<br><img src=\"images/oui.gif\" alt=\"\"> fichier xistant &nbsp;&nbsp;&nbsp;&nbsp;<img src=\"images/non.gif\" alt=\"\"> fichier inxistant" }
   puts $htmlpage "</div><br>"
   puts $htmlpage "</td></tr></table>"
}